// BonTestDlg.cpp : t@C
//

#include "stdafx.h"
#include "BonTest.h"
#include "BonTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonTestDlg _CAO
CBonTestDlg::CBonTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonTestDlg::IDD, pParent)
	, m_iChannel(0)
	, m_iService(0)
	, m_iSoundMode(0)
	, m_iSpace(0)
	, m_hDrvLib(NULL)
	, m_byCurAudioChannel(0)
	, m_bFullscreen(false)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	// INIL[o^
	m_csRecordPath.RegisterKey(CONFSECT_GENERAL, TEXT("RecordPath"), TEXT("C:\\BonTest.ts"));
}

void CBonTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBonSampleDlg)
	DDX_CBIndex(pDX, IDC_CHCOMBO, m_iChannel);
	DDX_CBIndex(pDX, IDC_SVCOMBO, m_iService);
	DDX_CBIndex(pDX, IDC_SPCOMBO, m_iSpace);
	//}}AFX_DATA_MAP	
}

BEGIN_MESSAGE_MAP(CBonTestDlg, CDialog)
	//{{AFX_DATA_MAP(CBonSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()	
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RESET, &CBonTestDlg::OnBnClickedReset)
	ON_CBN_SELCHANGE(IDC_SPCOMBO, &CBonTestDlg::OnSelChangeSpace)
	ON_CBN_SELCHANGE(IDC_CHCOMBO, &CBonTestDlg::OnSelChangeChannel)
	ON_CBN_SELCHANGE(IDC_SVCOMBO, &CBonTestDlg::OnSelChangeService)
	ON_BN_CLICKED(IDC_STARTRECORD, &CBonTestDlg::OnBnClickedStartRecord)
	ON_BN_CLICKED(IDC_STOPRECORD, &CBonTestDlg::OnBnClickedStopRecord)
	ON_BN_CLICKED(IDC_BROWSEPATH, &CBonTestDlg::OnBnClickedBrowsePath)
	ON_BN_CLICKED(IDC_OPENFILE, &CBonTestDlg::OnBnClickedOpenFile)
	ON_BN_CLICKED(IDC_PLAY, &CBonTestDlg::OnBnClickedPlay)
	ON_BN_CLICKED(IDC_PAUSE, &CBonTestDlg::OnBnClickedPause)
	ON_BN_CLICKED(IDOK, &CBonTestDlg::OnBnClickedClose)
	ON_BN_CLICKED(IDCANCEL, &CBonTestDlg::OnBnClickedClose)
	ON_CBN_SELCHANGE(IDC_SOUNDCMB, &CBonTestDlg::OnCbnSelchangeSoundcmb)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CBonTestDlg bZ[W nh

BOOL CBonTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
//	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	CBonTestCmdLineInfo &cCmdLine = theApp.GetCommandLineInfo();
	TCHAR szDriverName[MAX_PATH] = _T("BonDriver.dll");
	if(cCmdLine.IsDriverSelect()) {
		_tcscpy(szDriverName,cCmdLine.GetDriverPath().GetString());
		}
	TRACE(_T("BonDriver = \"%s\"\n"),szDriverName);


	// TEh̓X[ɂ
	CComboBox *pCmb = (CComboBox*)GetDlgItem(IDC_SOUNDCMB);
	ASSERT(pCmb);
	m_iSoundMode = 0;
	pCmb->SetCurSel(m_iSoundMode);

	// {[
	m_pVolume = (CSliderCtrl*)GetDlgItem(IDC_VOLUME);
	ASSERT(m_pVolume);
	m_pVolume->SetRange(0,100);
	m_pVolume->SetPageSize(5);
	m_pVolume->SetPos(100);

	// EBhEŒ菈(IvVw莞)
	if(cCmdLine.IsFixWindow()){
		DWORD dwStyle = GetWindowLong(GetSafeHwnd(),GWL_STYLE);
		if(dwStyle&WS_THICKFRAME){
			// TCYύXgāA[_t[ɂ
			dwStyle&=~WS_THICKFRAME;
			dwStyle|=DS_MODALFRAME;
			}
		SetWindowLong(GetSafeHwnd(),GWL_STYLE,dwStyle);
		}

	// EBhEACeʒu̕ۑ
	CWnd *pWnd;
	RECT rcDlg, rcWnd;
	POINT ptOffset = {0,0};
	GetClientRect(&rcDlg);
	ClientToScreen(&ptOffset);

	pWnd = GetDlgItem(IDC_VIEW);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iViewRightMargin = rcDlg.right - (rcWnd.right-rcWnd.left);
	m_stSavePositon.iViewBottomMargin= rcDlg.bottom- (rcWnd.bottom-rcWnd.top);

	pWnd = GetDlgItem(IDC_OPENFILE);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iOpenFileLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iOpenFileBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_PAUSE);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iPauseLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iPauseBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_STARTRECORD);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iStartRecordLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iStartRecordBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_STOPRECORD);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iStopRecordLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iStopRecordBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_RECORDPATH);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iRecordPathLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iRecordPathBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_BROWSEPATH);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iBrowsePathLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iBrowsePathBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_INFOBAR);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iInfoBarLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iInfoBarBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_RESET);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iResetLeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iResetBottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_STATIC1);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iStatic1LeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iStatic1BottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	pWnd = GetDlgItem(IDC_STATIC2);
	ASSERT(pWnd);
	pWnd->GetWindowRect(&rcWnd);
	m_stSavePositon.iStatic2LeftOffset= rcWnd.left - ptOffset.x;
	m_stSavePositon.iStatic2BottomToTopOffset = rcWnd.top-ptOffset.y - rcDlg.bottom;

	// hCoJ
	m_hDrvLib = LoadLibrary(szDriverName);
	IBonDriver *pBonDriver = NULL;
	if(!m_hDrvLib){
		CString errmsg;
		errmsg.Format(_T("DLL̃I[vɎs܂\n%s"),szDriverName);
		AfxMessageBox(errmsg);
		return TRUE;
	}


	// ݒ蕜
	SetDlgItemText(IDC_RECORDPATH, m_csRecordPath);

	// DTVGWI[v
	if(m_DtvEngine.OpenEngine(this, GetDlgItem(IDC_VIEW)->GetSafeHwnd(),GetSafeHwnd(),m_hDrvLib,!cCmdLine.IsNotDescramble())){
		// vr[Jn
		m_DtvEngine.EnablePreview();
		}

	// `lXV
	CComboBox *pSpaceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SPCOMBO));
	CComboBox *pChannelCombo = static_cast<CComboBox *>(GetDlgItem(IDC_CHCOMBO));

	if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2()){
		pSpaceCombo->ResetContent();
		pChannelCombo->ResetContent();

		// `[jOԖXV
		for(DWORD dwSpace = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace) ; dwSpace++){
			pSpaceCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace));
			}

		// `lXV
		for(DWORD dwChannel = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName(0UL, dwChannel) ; dwChannel++){
			pChannelCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetChannelName(0UL, dwChannel));
			}
		}
	
	pSpaceCombo->SetCurSel(0);	
	pChannelCombo->SetCurSel(0);	

	UpdateData(FALSE);
	SetTimer(1, 500UL, NULL);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		if( nID == SC_CLOSE)
		{
			CDialog::EndDialog(IDOK);
		} else {
			CDialog::OnSysCommand(nID, lParam);
		}
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBonTestDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B

	KillTimer(1);
	
	// DTVGWN[Y
	m_DtvEngine.CloseEngine();

	// hCo
	if(m_hDrvLib){
		FreeLibrary(m_hDrvLib);
		}
}

void CBonTestDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	
	// Mx擾
	CString csText, csTemp;
	csText.Format(TEXT("MxF@%.2fdB"), m_DtvEngine.m_BonSrcDecoder.GetSignalLevel());
	SetDlgItemText(IDC_STATUS, csText);

	if(GetDlgItem(IDC_VIEW)->GetWindow(GW_CHILD)){
		GetDlgItem(IDC_VIEW)->GetWindow(GW_CHILD)->InvalidateRect(NULL);
		}

	// Xe[^Xo[XV
	csText = TEXT("");
	
	csTemp.Format(TEXT("́F %lu    "), m_DtvEngine.m_TsPacketParser.GetInputPacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("óF %lu    "), m_DtvEngine.m_TsPacketParser.GetOutputPacketCount());
	csText += csTemp;

	csTemp.Format(TEXT("G[F %lu    "), m_DtvEngine.m_TsPacketParser.GetErrorPacketCount());
	csText += csTemp;

	if(!theApp.GetCommandLineInfo().IsNotDescramble()){
		csTemp.Format(TEXT("RF %lu    "), m_DtvEngine.m_TsDescrambler.GetScramblePacketCount());
		csText += csTemp;
		}

	BYTE byX,byY;
	WORD wX,wY;
	if(m_DtvEngine.GetVideoSize(&wX,&wY)){
		csTemp.Format(TEXT("rfIF %dx%d"), wX , wY);
		csText += csTemp;

		if(m_DtvEngine.GetVideoAspectRatio(&byX,&byY)){
			csTemp.Format(TEXT("(%d:%d)"), byX , byY);
			csText += csTemp;
			long pBitRate = 0;
		}
		csText += _TEXT("    ");
	}

	BYTE byAudioChannel = m_DtvEngine.GetAudioCahnnelNum();
	if(byAudioChannel>0){
		// ݂͓񃖍EύX͍lĂȂ(ȂEITȂƂȂ)
		if(m_byCurAudioChannel != byAudioChannel) {
			// `lωꍇA[hX[ɂ
			CComboBox *pCmb = (CComboBox*)GetDlgItem(IDC_SOUNDCMB);
			ASSERT(pCmb);
			pCmb->SetCurSel(0);
			m_iSoundMode = 0;
			m_DtvEngine.SetStereoMode(0);
			m_byCurAudioChannel = byAudioChannel;
			}
		switch(byAudioChannel){
		case 1:
			csTemp.Format(TEXT("I[fBIF m    "));
			break;
		case 2:
			switch(m_iSoundMode){
			case 1:
				csTemp.Format(TEXT("I[fBIF XeI()    "));
				break;
			case 2:
				csTemp.Format(TEXT("I[fBIF XeI(E)    "));
				break;
			default:
				csTemp.Format(TEXT("I[fBIF XeI    "));
				break;
			}
			break;
		case 6:
			csTemp.Format(TEXT("I[fBIF 5.1ch    "));
			break;
		default:
			csTemp.Format(TEXT("I[fBIF %dch    "), byAudioChannel);
			break;
		}		
		csText += csTemp;
		}	

	csTemp.Format(TEXT("^TCYF %.2lfMB"), (double)m_DtvEngine.m_FileWriter.GetWriteSize() / (1024.0 * 1024.0));
	csText += csTemp;

	SetDlgItemText(IDC_INFOBAR, csText);

	CDialog::OnTimer(nIDEvent);
}


void CBonTestDlg::OnLButtonDblClk(UINT nFlags,CPoint point)
{
	// _uNbNŃtXN[ƃEBhE؂ւ	
	m_DtvEngine.SwitchFullscreen();

	CDialog::OnLButtonDblClk(nFlags,point);
}

void CBonTestDlg::OnSize(UINT nType, int cx, int cy)
{
	// EBhẼTCYςƂ
	CDialog::OnSize(nType,cx,cy);
	ReSizeDlgItem();
}

void CBonTestDlg::ReSizeDlgItem()
{
	// qEBhE𓮂
	RECT rcRect;
	GetClientRect(&rcRect);
	int cx = rcRect.right - rcRect.left;
	int cy = rcRect.bottom - rcRect.top;

	CWnd *pWnd;
	pWnd = GetDlgItem(IDC_VIEW);
	if(pWnd){
		pWnd->SetWindowPos(NULL,0,0,cx-m_stSavePositon.iViewRightMargin,cy-m_stSavePositon.iViewBottomMargin,SWP_NOMOVE|SWP_NOREDRAW);
		m_DtvEngine.SetViewSize(cx-m_stSavePositon.iViewRightMargin,cy-m_stSavePositon.iViewBottomMargin);
		}
	pWnd = GetDlgItem(IDC_OPENFILE);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iOpenFileLeftOffset,cy+m_stSavePositon.iOpenFileBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_PAUSE);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iPauseLeftOffset,cy+m_stSavePositon.iPauseBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_STARTRECORD);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iStartRecordLeftOffset,cy+m_stSavePositon.iStartRecordBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_STOPRECORD);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iStopRecordLeftOffset,cy+m_stSavePositon.iStopRecordBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_RECORDPATH);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iRecordPathLeftOffset,cy+m_stSavePositon.iRecordPathBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_BROWSEPATH);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iBrowsePathLeftOffset,cy+m_stSavePositon.iBrowsePathBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_INFOBAR);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iInfoBarLeftOffset,cy+m_stSavePositon.iInfoBarBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_RESET);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iResetLeftOffset,cy+m_stSavePositon.iResetBottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_STATIC1);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iStatic1LeftOffset,cy+m_stSavePositon.iStatic1BottomToTopOffset,0,0,SWP_NOSIZE);
		}
	pWnd = GetDlgItem(IDC_STATIC2);
	if(pWnd){
		pWnd->SetWindowPos(NULL,m_stSavePositon.iStatic2LeftOffset,cy+m_stSavePositon.iStatic2BottomToTopOffset,0,0,SWP_NOSIZE);
		}
	InvalidateRect(NULL,FALSE);
}

void CBonTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(pScrollBar==(CScrollBar*)m_pVolume){
		// ʐݒ(-40dB܂łpƎvA0dBŖ)
		int iPos = m_pVolume->GetPos() - 100;		
		if(m_DtvEngine.SetVolume((float)iPos)){
			CWnd *pWnd = GetDlgItem(IDC_STATUS_VOLUME);
			ASSERT(pWnd);
			CString cVol;
			cVol.Format(_T("%d dB"),iPos);
			pWnd->SetWindowText(cVol);
			}
		}
}

void CBonTestDlg::OnBnClickedReset()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_DtvEngine.ResetEngine();
}

void CBonTestDlg::OnSelChangeSpace()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	// `lXV
	if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2()){
		CComboBox *pChannelCombo = static_cast<CComboBox *>(GetDlgItem(IDC_CHCOMBO));
		pChannelCombo->ResetContent();

		// `lXV
		for(DWORD dwChannel = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName((DWORD)m_iSpace, dwChannel) ; dwChannel++){
			pChannelCombo->AddString(m_DtvEngine.m_BonSrcDecoder.GetChannelName((DWORD)m_iSpace, dwChannel));
			}

		pChannelCombo->SetCurSel(0);	

		if(!m_DtvEngine.SetChannel((BYTE)m_iSpace, 0U)){
			::AfxMessageBox(TEXT("`l̐ؑւɎs܂B"));
			}
		}
}

void CBonTestDlg::OnSelChangeChannel()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(!m_DtvEngine.SetChannel((BYTE)m_iSpace, (WORD)m_iChannel)){
		::AfxMessageBox(TEXT("`l̐ؑւɎs܂B"));
		}
		
	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
	pServiceCombo->ResetContent();
	pServiceCombo->AddString(TEXT("`lύX..."));
	pServiceCombo->SetCurSel(0);
}

void CBonTestDlg::OnSelChangeService()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(!m_DtvEngine.SetService(m_iService)){
		::AfxMessageBox(TEXT("T[rX̐ؑւɎs܂B"));
		}
}

const DWORD CBonTestDlg::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// SɎb
	CProgManager *pProgManager = static_cast<CProgManager *>(pParam);
	CComboBox *pServiceCombo = static_cast<CComboBox *>(GetDlgItem(IDC_SVCOMBO));
	
	pServiceCombo->ResetContent();
	TCHAR szServiceName[1024];
	
	// T[rXXV
	for(WORD wIndex = 0U ; wIndex < pProgManager->GetServiceNum() ; wIndex++){
		if(pProgManager->GetServiceName(szServiceName, wIndex)){
			pServiceCombo->AddString(szServiceName);		
			}
		else{
			pServiceCombo->AddString(TEXT("T[rX擾..."));
			}
		}	

	pServiceCombo->SetCurSel(pEngine->GetService());

	return 0UL;
}

void CBonTestDlg::OnBnClickedStartRecord()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@C݊Jn
	if(!m_DtvEngine.m_FileWriter.OpenFile(m_csRecordPath)){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		return;		
		}
		
	// Rg[ԕύX
	GetDlgItem(IDC_STARTRECORD)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPRECORD)->EnableWindow(TRUE);
}

void CBonTestDlg::OnBnClickedStopRecord()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@CݏI
	m_DtvEngine.m_FileWriter.CloseFile();
	
	// Rg[ԕύX
	GetDlgItem(IDC_STARTRECORD)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOPRECORD)->EnableWindow(FALSE);
}

void CBonTestDlg::OnBnClickedBrowsePath()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
	// t@CI
	CFileDialog Dlg(FALSE, TEXT("ts"), m_csRecordPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, TEXT("MPEG2-TS (*.ts)|*.ts||"));
	if(Dlg.DoModal() != IDOK)return;
	
	// Rg[XV
	m_csRecordPath = Dlg.GetPathName();
	SetDlgItemText(IDC_RECORDPATH, m_csRecordPath);
}

void CBonTestDlg::OnBnClickedOpenFile()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CFileDialog Dlg(TRUE, TEXT("ts"), NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TEXT("TSt@C (*.ts)|*.ts||"));
	if(Dlg.DoModal() != IDOK)return;

	if(!m_DtvEngine.PlayFile(Dlg.GetPathName())){
		::AfxMessageBox(TEXT("t@C̃I[vɎs܂B"));
		}
}

void CBonTestDlg::OnBnClickedPlay()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	
}

void CBonTestDlg::OnBnClickedPause()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_DtvEngine.StopFile();
}

void CBonTestDlg::OnBnClickedClose()
{
	// WIDOK,IDCANCEL͏Ȃ
}

void CBonTestDlg::OnCbnSelchangeSoundcmb()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CComboBox *pCmb = (CComboBox*)GetDlgItem(IDC_SOUNDCMB);
	ASSERT(pCmb);
	m_iSoundMode = pCmb->GetCurSel();
	m_DtvEngine.SetStereoMode(m_iSoundMode);
}
