// BonTestDlg.h : wb_[ t@C
//

#pragma once

#include "DtvEngine.h"
#include "ConfigData.h"


// CBonTestDlg _CAO
class CBonTestDlg : public CDialog, public CDtvEngineHandler
{
// RXgNV
public:
	CBonTestDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_BONTEST_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

// 
protected:
	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
	
	HICON m_hIcon;
	CDtvEngine m_DtvEngine;
	CConfigString m_csRecordPath;
	HMODULE m_hDrvLib;

	CSliderCtrl *m_pVolume;
	struct {
		// IDC_VIEW
		int iViewRightMargin;
		int iViewBottomMargin;
		// IDC_OPENFILE
		int iOpenFileLeftOffset;
		int iOpenFileBottomToTopOffset;
		// IDC_PAUSE
		int iPauseLeftOffset;
		int iPauseBottomToTopOffset;
		// IDC_STARTRECORD
		int iStartRecordLeftOffset;
		int iStartRecordBottomToTopOffset;
		// IDC_STOPRECORD
		int iStopRecordLeftOffset;
		int iStopRecordBottomToTopOffset;
		// IDC_RECORDPATH
		int iRecordPathLeftOffset;
		int iRecordPathBottomToTopOffset;
		// IDC_BROWSEPATH
		int iBrowsePathLeftOffset;
		int iBrowsePathBottomToTopOffset;
		// IDC_INFOBAR
		int iInfoBarLeftOffset;
		int iInfoBarBottomToTopOffset;
		// IDC_RESET
		int iResetLeftOffset;
		int iResetBottomToTopOffset;
		// IDC_STATIC1
		int iStatic1LeftOffset;
		int iStatic1BottomToTopOffset;
		// IDC_STATIC2
		int iStatic2LeftOffset;
		int iStatic2BottomToTopOffset;
	} m_stSavePositon;

	void ReSizeDlgItem();
	
public:
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnLButtonDblClk(UINT nFlags,CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);	
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedReset();
	afx_msg void OnSelChangeSpace();
	afx_msg void OnSelChangeChannel();
	afx_msg void OnSelChangeService();
	afx_msg void OnBnClickedStartRecord();
	afx_msg void OnBnClickedStopRecord();
	afx_msg void OnBnClickedBrowsePath();
	afx_msg void OnBnClickedOpenFile();
	afx_msg void OnBnClickedPlay();
	afx_msg void OnBnClickedPause();
	afx_msg void OnBnClickedClose();
	afx_msg void OnCbnSelchangeSoundcmb();

	int m_iSpace;
	int m_iChannel;
	int m_iService;
	int m_iSoundMode;
	BYTE m_byCurAudioChannel;
	bool m_bFullscreen;
};
